#pragma once

#include <GL/glew.h>
#include <FK/FK.h>


class GLSLModel : public fk_Model {
  private:
	GLuint		vpID, fpID, shID;	// VF[_ǗIDێϐ
	bool		useTex, useSatBle;	// (b)샂[h
	
	// ֐
	void LoadShaderFile(GLuint id, const char *argFileName);
	bool PrintShaderInfoLog(GLuint shader);

  public:
	GLSLModel(void);
	~GLSLModel();
	
	void	preShader(void);		// `撼OɃVF[_Lɂ鏈
	void	postShader(void);		// `撼ɃVF[_𖳌ɂ鏈
	
	// gVF[_vOǂݍŏ鏈
	void	initShader(const char *, const char *);
	// (b)샂[hύX
	void	setTexUse(bool);
	void	setSatUse(bool);
};
