#pragma once
#include <FK/FK.h>
#include <Cg/cg.h>
#include <Cg/cgGL.h>

class fk_VolumeLineModel : public fk_Model {
	// ȉ 5  Cg ֌W̏𐧌䂷Rg[IϐƎv
	CGcontext	cg_context;				// Cg ̃ReLXg
	CGprofile	vp_profile;				// o[ebNXVF[_̃vt@C
	CGprofile	fp_profile;				// tOgVF[_̃vt@C
	CGprogram	vertex_shader;			// o[ebNXVF[_ǂݍݗpϐ
	CGprogram	fragment_shader;		// tOgVF[_ǂݍݗpϐ

	CGparameter	model_view_proj_matrix;	// ŏIIȎˉeϊp̍s
	CGparameter	model_view_matrix;		// _ʒu̍Wɕϊ鍇s

	CGparameter param0, param1, param8, param9;

	CGparameter	f_tex[2];
	fk_Image	*ref_image;
	fk_TexID	tex[2];
	fk_Point	dummyShape;

	vector<fk_Vector>	posArray;
	vector<double>		lenArray;

	void	draw_line(fk_Vector, fk_Vector, float);

  public:
	fk_VolumeLineModel(void);
	~fk_VolumeLineModel();

	// fk_Model ŉz֐ƂĒ`Ă֐
	void	preShader(void);
	void	postShader(void);
	void	cgInit(void);

	void		setImage(fk_Image *);
	fk_Image *	getImage(void);

	void	allClear(void);
	int		pushLine(fk_Vector, fk_Vector, double);
	bool	changeLine(int, fk_Vector, fk_Vector, double);
	int		getLinesNum(void);
	bool	getLineInfo(int, fk_Vector *, fk_Vector *, double *);
};
